// Solve the Momentum equation

MRF.correctBoundaryVelocity(U);

tmp<fvVectorMatrix> tUEqn
(
    fvm::ddt(U) 
  + fvm::div(phi, U)
  + MRF.DDt(U)
 ==
    fvOptions(U)
//  + constEq.divTau(U)
    + fvc::div(tau)/rho
    + fvm::laplacian(etaS/rho, U)       
);

fvVectorMatrix& UEqn = tUEqn.ref();

UEqn.relax();

fvOptions.constrain(UEqn);
 
spSolverU->solve(UEqn == -fvc::grad(p));  

fvOptions.correct(U);
 
