{
 // Velocity gradient tensor
    volTensorField L = fvc::grad(U);
   
    volTensorField a(L*0.0);
    scalar t1(0.0), t2(0.0), t3(0.0), B1(0.0), B2(0.0), B3(0.0), w1(0.0), w2(0.0), w3(0.0), D(0.0);
    
    forAll(b, cellI)
    { 
       t1 = b[cellI].yy()+b[cellI].zz();
       t2 = b[cellI].xx()+b[cellI].zz(); 
       t3 = b[cellI].xx()+b[cellI].yy();

       B1 = b[cellI].yz();  B2 = b[cellI].xz();  B3 = b[cellI].xy();

       w1 =  b[cellI].xy()*L[cellI].xx() - b[cellI].xx()*L[cellI].xy()
           + b[cellI].yy()*L[cellI].yx() - b[cellI].xy()*L[cellI].yy()
           + b[cellI].yz()*L[cellI].zx() - b[cellI].xz()*L[cellI].zy();

       w2 =  b[cellI].xz()*L[cellI].xx() - b[cellI].xx()*L[cellI].xz()
           + b[cellI].zz()*L[cellI].zx() - b[cellI].xz()*L[cellI].zz()
           + b[cellI].yz()*L[cellI].yx() - b[cellI].xy()*L[cellI].yz();

       w3 =  b[cellI].xz()*L[cellI].xy() - b[cellI].xy()*L[cellI].xz()
           + b[cellI].yz()*L[cellI].yy() - b[cellI].yy()*L[cellI].zy()
           + b[cellI].zz()*L[cellI].zy() - b[cellI].yz()*L[cellI].zz();

       D = t1*(t2*t3-B1*B1) - B2*(B2*t2+B1*B3) - B3*(B2*B1 + B3*t3);

       a[cellI].xy() = (  (t1*t2-B3*B3)*w1 - (B1*t1+B3*B2)*w2 + (B2*t2+B1*B3)*w3 )/D;
       a[cellI].xz() = ( -(B1*t1+B3*B2)*w1 + (t1*t3-B2*B2)*w2 - (B2*B1+B3*t3)*w3 )/D;
       a[cellI].yz() = (  (B2*t2+B1*B3)*w1 - (B2*B1+B3*t3)*w2 + (t2*t3-B1*B1)*w3 )/D;
 
       a[cellI].yx() = -a[cellI].xy();
       a[cellI].zx() = -a[cellI].xz();
       a[cellI].zy() = -a[cellI].yz();
    }     

    fvSymmTensorMatrix bEqn
    (
         fvm::ddt(b)
       + fvm::div(phi, b) 
     ==
         symm((b&L) + (a & b))
       + (0.5/lambda) * inv( b.T() ) * (L2 /(L2-3))
       - fvm::Sp((0.5/lambda) * (exp(d) / L2), b)
//       - fvm::Sp(0.5/(lambda * (1-(tr(b.T() & b) / L2))), b)
       + fvm::laplacian(0.5 * k, b)
    );

    bEqn.relax();
    bEqn.solve();

    // Convert from b to tau
    dimensionedSymmTensor Itensor
    ( 
        "Identity", 
        dimensionSet(0, 0, 0, 0, 0, 0, 0), 
        symmTensor::I 
    );

 //   volScalarField f = L2/(L2 - tr(b.T() & b));

    volScalarField f = exp(d);

    lck = 1 - (tr(b.T() & b) / L2);

    Info << min(lck) << endl;

    scalar e = L2.value()/(L2.value() - 3.);

    tau = (etaP/lambda) * symm( f*(b&b) - e*Itensor);

    tau.correctBoundaryConditions();

}

